// Andreas Kirsch 2007

$Firework::Layer = 3;

$Firework::TargetGranularity = 5.0;
$Firework::QuantityScale = 0.3;

$Firework::Duration = 5.0;

$Firework::HueSpeed = 100.0;
$Firework::HueAnimationRate = 1 / 20.0;

function Level::createFireworkFromPointList( %this, %pointList, %granularity ) {
   t2dAssert( %granularity > 0, "Bad granularity!" );
   
   %firework = new t2dSceneObjectGroup() {
      class = Firework;
   };
   
   %this.fireworks.add( %firework );
   
   %skip = $Firework::TargetGranularity / %granularity;
   
   %pointCount = getFieldCount( %pointList );
   for( %i = 0 ; %i < %pointCount ; %i += %skip ) {
      %position = getField( %pointList, %i );
      
      %effect = new t2dParticleEffect() {      
         sceneGraph = %this;
         effectFile = "~/data/particles/magic_trail_special.eff";
         effectMode = KILL;
         effectTime = $Firework::Duration;
         
         position = %position;
         
         layer = $Firework::Layer;
      };      
      %firework.add( %effect );
      
      %effect.setQuantityScale( $Firework::QuantityScale );
      %effect.playEffect( true );
      
      %hue = getRandom() * 360.0;
      %rgb = convertHSLtoRGB( %hue, 1.0, 0.5 );
      %effect.setColor( getWord( %rgb, 0 ), getWord( %rgb, 1 ), getWord( %rb, 2 ), 1.0 );
      
      //$EffectCount++;      
   }    
   //echo( $EffectCount );
   
   //%firework.timerId = %firework.schedule( 1000.0 * $Firework::HueAnimationRate, onTimer );
}

//function Firework::onTimer( %this ) {
   //%count = %this.getCount();
   //for( %i = 0 ; %i < %count ; %i++ ) {
      //%effect = %this.getObject( %i );
      //
      //%hue = %effect.hue = mWrap( %effect.hue + $Firework::HueSpeed * $Firework::HueAnimationRate, 0.0, 360.0 );
      ////echo( %effect SPC %effect.hue );
      //// update color
      //%rgb = convertHSLtoRGB( %hue, 1.0, 0.5 );
      //%effect.setColor( getWord( %rgb, 0 ), getWord( %rgb, 1 ), getWord( %rb, 2 ), 1.0 );
   //}
   //
   //%this.timerId = %this.schedule( 1000.0 * $Firework::HueAnimationRate, onTimer );
//}
//
//function Firework::onRemove( %this ) {
   //cancel( %this.timerId );
//}

function t2dParticleEffect::setColor( %this, %red, %green, %blue, %alpha ) {
   %emitter = %this.getEmitterObject( 0 );
   %emitter.selectGraph( "red_life" );
   %emitter.setDataKeyValue( 0, %red );
   %emitter.selectGraph( "green_life" );
   %emitter.setDataKeyValue( 0, %green );
   %emitter.selectGraph( "blue_life" );
   %emitter.setDataKeyValue( 0, %blue );
   %emitter.selectGraph( "visibility_life" );
   %emitter.setDataKeyValue( 0, %alpha );
   
   %emitter = %this.getEmitterObject( 1 );
   %emitter.selectGraph( "red_life" );
   %emitter.setDataKeyValue( 0, %red );
   %emitter.selectGraph( "green_life" );
   %emitter.setDataKeyValue( 0, %green );
   %emitter.selectGraph( "blue_life" );
   %emitter.setDataKeyValue( 0, %blue );
   %emitter.selectGraph( "visibility_life" );
   %emitter.setDataKeyValue( 0, %alpha );
}

function t2dParticleEffect::setQuantityScale( %this, %quantityScale ) {
   %this.selectGraph( "quantity_scale" );
   %this.setDataKeyValue( 0, %quantityScale );   
}
