//---------------------------------------------------------------------------------------------
// Torque Game Builder
// Copyright (C) GarageGames.com, Inc.
//---------------------------------------------------------------------------------------------

exec( "./helpers.cs" );
exec( "./debugHelpers.cs" );

exec( "./t2dShape.cs" );
exec( "./t2dCustomButton.cs" );
exec( "./uiButton.cs" );

exec( "./hsl.cs" );

exec( "./compileDrawPaths.cs" );
exec( "./contour.cs" );
exec( "./stroke.cs" );
exec( "./input.cs" );

exec( "./firework.cs" );

exec( "./score.cs" );
exec( "./highscores.cs" );

exec( "./menu.cs" );

$Background::Level = "~/data/levels/background.t2d";

//---------------------------------------------------------------------------------------------
// startGame
// All game logic should be set up here. This will be called by the level builder when you
// select "Run Game" or by the startup process of your game to load the first level.
//---------------------------------------------------------------------------------------------
function startGame(%level, %hideGUI)
{
   if( $GameRunning ) {
      endGame();
   }
   $GameRunning = true;
   // Set The GUI.
   Canvas.setContent(mainScreenGui);
   Canvas.setCursor(DefaultCursor);
   
   moveMap.push();   
      
   if( isFile( %level ) || isFile( %level @ ".dso"))
      sceneWindow2D.loadLevel(%level);
   
   if( !sceneBackground2D.loaded ) {
      sceneBackground2D.loadLevel( expandFilename( $Background::Level ) );
      sceneBackground2D.loaded = true;
   }
   
   if( !%hideGUI ) {
      sceneGUI2D.loadLevel( expandFilename( "~/data/levels/levelGUI.t2d" ) );
   } else {
      sceneGUI2D.resetSceneGraph();
   }
}

//---------------------------------------------------------------------------------------------
// endGame
// Game cleanup should be done here.
//---------------------------------------------------------------------------------------------
function endGame()
{
   sceneWindow2D.endLevel();
   moveMap.pop();
}
