// Andreas Kirsch 2007

$Highscore::File = "~/highscores.dat";

function loadHighscores( %this ) {
   safeRemove( Highscores );
   
   exec( $Highscore::File );
   
   if( !isObject( Highscores ) ) {
      new ScriptObject( Highscores ) {
         count = 6;
         
         score0 = $Game::LevelCount * 960000;
         score1 = $Game::LevelCount * 640000;
         score2 = $Game::LevelCount * 320000;
         score3 = $Game::LevelCount * 160000;
         score4 = $Game::LevelCount * 80000;
         score5 = $Game::LevelCount * 40000;
      };
   }       
}

function saveHighscores( %this ) {
   Highscores.save( expandFilename( $Highscore::File ), false );
}

function Highscores::getText( %this ) {
   for( %i = 0 ; %i < %this.count ; %i++ ) {
      %text = %text @ mFloatLength( %this.score[ %i ], 0 ) @ "\n";
   }
   return %text;
}

function Highscores::addScore( %this, %newScore ) {
   for( %i = 0 ; %i < %this.count ; %i++ ) {
      if( %this.score[ %i ] < %newScore ) {
         break;
      }
   }
   
   if( %this.count == %i ) {
      return;
   }
   
   %index = %i;
   
   for( %i = %this.count - 1 ; %i > %index ; %i-- ) {
      %this.score[ %i ] = %this.score[ %i - 1 ];
   }
   
   %this.score[ %index ] = %newScore;
}