// Andreas Kirsch 2007

function convertHSLtoRGB( %hue, %saturation, %lightness ) {
   if( %lightness < 0.5 ) {
      %Q = %lightness * (1.0 + %saturation);
   } else {
      %Q = %lightness + %saturation - %lightness * %saturation;
   }
   %P = 2 * %lightness - %Q;
   
   %H = %hue / 360;
   
   %T0 = %H + 1 / 3;
   %T1 = %H;
   %T2 = %H - 1 / 3;
   
   for( %i = 0 ; %i < 3 ; %i++ ) {
      %T = %T[ %i ];
      if( %T < 0.0 ) {
         %T += 1.0;
      } else if( %T > 1.0 ) {
         %T -= 1.0;
      }
      
      if( %T < 1 / 6 ) {
         %r = %P + ((%Q - %P) * 6.0 * %T);
      } else if( %T < 1 / 2 ) {
         %r = %Q;
      } else if( %T < 2 / 3 ) {
         %r = %P + ((%Q - %P) * 6.0 * (2 / 3 - %T));
      } else {
         %r = %P;
      }
      %r[ %i ] = %r;
   }
   
   return %r[ 0 ] SPC %r[ 1 ] SPC %r[ 2 ];
}

