// Andreas Kirsch 2007

$Menu::Level = "~/data/levels/levelMenu.t2d";

$Game::LevelList = "levelLinesCP.t2d levelNikolausCP.t2d testCP.t2d levelCirclesCP.t2d levelWavesCP.t2d";
$Game::LevelCount = getWordCount( $Game::LevelList );
$Game::LevelIndex = -1;

$Menu::ButtonDelay = 0.700 * 1000.0;

function Menu::onLevelLoaded( %this ) {
   sceneWindow2d.setUseObjectMouseEvents( true );
   sceneWindow2d.setUseWindowMouseEvents( false );
}

function Menu::showHighscore( %this, %state ) {
   if( %state ) {
      HighscoreList.text = Highscores.getText();
   } else {
      BackButton.text = "back";
   } 
   
   BackButton.setVisible( %state );
   HighscoreOrder.setVisible( %state );
   HighscoreList.setVisible( %state );
   
   QuitButton.setVisible( !%state );
   HighScoreButton.setVisible( !%state );
   StartGameButton.setVisible( !%state );
}

// TODO: move this somewhere else
function Level::onLevelLoaded( %this ) {
   sceneWindow2d.setUseObjectMouseEvents( false );
   sceneWindow2d.setUseWindowMouseEvents( true );
   
   %this.contours = new t2dSceneObjectGroup();
   %this.fireworks = new t2dSceneObjectGroup();
}

function Level::onLevelEnded( %this ) {
   safeRemove( %this.contours );
   safeRemove( %this.fireworks );
}

function QuitButton::onClick( %this ) {
   schedule( $Menu::ButtonDelay, 0, exitDemo );
}

function HighScoreButton::onClick( %this ) {
   Menu.schedule( $Menu::ButtonDelay, showHighscore, true );
}

function StartGameButton::onClick( %this ) {
   cancel( %this.eventID );
   $Game::LevelIndex = -1;
   %this.eventID = schedule( $Menu::ButtonDelay, 0, startNextLevel );   
}

function BackButton::onClick( %this ) {
   Menu.schedule( $Menu::ButtonDelay, showHighscore, false );
}

function showMenu( %showHighscore ) {
   startGame( expandFilename( $Menu::Level ), true );
   
   if( %showHighscore ) {
      BackButton.text = "Continue";
      Menu.showHighscore( true );
   }
}

function startNextLevel( %this ) {
   $Game::LevelIndex++;
   if( $Game::LevelIndex < $Game::LevelCount ){   
      %levelName = getWord( $Game::LevelList, $Game::LevelIndex );
      startGame( expandFilename( "~/data/levels/" @ %levelName ), false );
   } else  {
      // TODO: hack hack
      %showHighscore = false;
      if( isObject( Score ) ) {
         Highscores.addScore( Score.totalScore );
         safeRemove( Score );
         
         %showHighscore = true;
      }
      showMenu( %showHighscore );
   }
}
