// Andreas Kirsch 2007

$Score::PointPainted = 10;
$Score::ContourPainted = 100;
$Score::AllPainted = 1000;

// Score object
package ScorePackage {
   function Level::onLevelLoaded( %this ) {
      // TODO: hack hack
      %this.schedule( 100, createScore );
      Parent::onLevelLoaded( %this );
   }
};
activatePackage( ScorePackage );

function Level::createScore( %this ) {
   // TODO: hack hack..
   if( !isObject( Score ) ) {
      %score = %this.score = new ScriptObject( Score ) {
         sceneGraph = %this;
         totalScore = 0;
      };
   } else {
      %score = Score;
      %score.sceneGraph = %this;
   }
   
   %score.strokeCount = 0;
   %score.paintedContourCount = 0;
   %score.paintedPointCount = 0;

   %score.strokeContours = new SimSet();
   
   %score.resetStroke();
   
   %contours = %this.contours;
   %contourCount = %score.contourCount = %contours.getCount();
   
   %score.totalPointCount = 0;
   for( %i = 0 ; %i < %contourCount ; %i++ ) {
      %contour = %contours.getObject( %i );
               
      %score.strokesForContour[ %contour ] = 0;
      
      %score.paintedPointContourCount[ %contour ] = 0;      
      
      %pointContourCount = %contour.pointCount;      
      %score.pointContourCount[ %contour ] = %contour.pointCount;
      %score.totalPointCount += %pointContourCount;
   }
   
   %score.updateGUI();
}

function Score::pointPainted( %this, %contour ) {
   %this.paintedPointCount++;
   %this.strokePaintedPointCount++;
   %this.strokePaintedInARow++;
   
   %this.strokeScore += $Score::PointPainted;
   
   %paintedPointContourCount = %this.paintedPointContourCount[ %contour ]++;
   if( %paintedPointContourCount == %this.pointContourCount[ %contour ] ) {
      %this.contourPainted( %this, %contour );
   }
}

function Score::contourPainted( %this, %contour ) {
   %strokeCount = %this.strokesForContour[ %contour ]++;
   
   if( %strokeCount == 1 ) {
      // double the score if it has happened in one stroke
      %this.strokeScore *= 2.0;
   }
   %this.strokeScore += $Score::ContourPainted;
   
   %this.strokePaintedContourCount++;
   
   %this.paintedContourCount++;
   if( %this.paintedContourCount == %this.contourCount ) {
      %this.allPainted( %this );
   }
}

function Score::allPainted( %this ) {
   if( %this.strokeCount == 1 ) {
      // double the score if it has happened in one stroke
      %this.strokeScore *= 2.0;      
   }
   %this.strokeScore += $Score::AllPainted;
   
   %this.finishStroke();
   
   // TODO: add game over, etc. screen
   %this.schedule( 1.0 * 1000.0, startFirework );
   
   Congratulations.visible = true;   
   
   // TODO: hack hack
   schedule( 1000.0 * ($Firework::Duration + 2.0), 0, startNextLevel );
}

function Score::startStroke( %this ) {
   %this.strokeCount++;
   
   %this.strokeStartTime = %this.sceneGraph.getSceneTime();
}

function Score::resetStroke( %this ) {
   %this.strokePaintedPointCount = 0;
   %this.strokeTimeMultiplier = 1;
   
   %this.strokeScore = 0;
   
   %this.strokePowerMultiplier = 1;
   %this.strokePaintedInARow = 0;
   
   %this.strokeComboMultiplier = 1;
   %this.strokePaintedContourCount = 0;
   
   %this.strokePreviousContourPoints = "";
   
   %this.incrementStrokesForContour();
}

function Score::finishStroke( %this ) {
   %this.totalScore += %this.strokeScore * (%this.strokeTimeMultiplier + %this.strokePowerMultiplier + %this.strokeComboMultiplier);
   
   // reset the stroke score info
   %this.resetStroke();
   
   %this.updateGUI();
}

function Score::calcTimeMultiplier( %this ) {
   %time = %this.sceneGraph.getSceneTime();
   %deltaTime = %time - %this.strokeStartTime;
   
   %pointsPerSecond = %this.strokePaintedPointCount / %deltaTime;
  
   %this.strokeTimeMultiplier = mCeil( %pointsPerSecond / 100 );
}

function Score::calcPowerMultiplier( %this ) {
   %this.strokePowerMultiplier = 1 + mFloor( %this.strokePaintedInARow / 200 );
}

function Score::calcComboMultiplier( %this ) {
   %this.strokeComboMultiplier = %this.strokePaintedContourCount + 1;
}

function Score::updateStrokeContours( %this, %points ) {
   // TODO: hack hack....
   %contours = %this.strokeContours;
   %count = getWordCount( %points );
   for( %i = 0 ; %i < %count ; %i++ ) {
      %point = getWord( %points, %i );
      %contour = %point.contour;
      if( isObject( %contour ) ) {
         %contours.add( %contour );
      }
   }
}

function Score::incrementStrokesForContour( %this ) {
   %contours = %this.strokeContours;
   %count = %contours.getCount();
   for( %i = 0 ; %i < %count ; %i++ ) {
      %contour = %contours.getObject( %i );
      %this.strokesForContour[ %contour ]++;
   }
   %contours.clear();
}

function Score::processStrokeUpdate( %this, %currentContourPoints ) {
   %this.updateStrokeContours( %currentContourPoints );
   
   %continuous = true;
   
   %count = getWordCount( %currentContourPoints );
   if( %count == 0 ) {
      %continuous = false;
   }
   
   for( %i = 0 ; %i < %count ; %i++ ) {
      %point = getWord( %currentContourPoints, %i );
      
      %point.acceptStroke();
      
      //// check whether the stroke is continuous or not
      //// all points need to be continuous to the previous if the whole thing wants to be continuous
      //%combinedPoints = %currentContourPoints SPC %this.strokePreviousContourPoints;
      //%result = %point.testForContinuousStroke( %combinedPoints );
      //if( %result == 0 ) {
         //%continuous = false;
      //} else if( %result == 1 ) {
         //%openEnded[ %point.contour ]++;
      //}
   }
   
   //echo( %openEnded );
   //%singleStrokeContinuous = false;
   //
   //%contours = %this.strokeContours;
   //%count = %contours.getCount();   
   //for( %i = 0 ; %i < %count ; %i++ ) {
      //%contour = %contours.getObject( %i );
      //if( %openEnded[ %contour ] < 2 ) {
         //%singleStrokeContinuous = true;
      //}
   //}
   
   // only reset if strokePreviousContourPoints is not empty, ie. the stroke isnt just beginning again
   if( !%continuous && %this.strokePreviousContourPoints !$= "" ) {
      //echo( "NC!" );
      
      // reset in a row stuff and combos
      %this.strokePaintedInARow = 0;
      %this.strokePaintedContourCount = 0;      
      
      // update strokeForContour
      %this.incrementStrokesForContour();
   }
      
   %this.calcTimeMultiplier();
   %this.calcPowerMultiplier();
   %this.calcComboMultiplier();
   
   %this.strokePreviousContourPoints = %currentContourPoints;
   
   %this.updateGUI();
   
   return %count > 0;
}

function Score::updateGUI( %this ) {
   TotalScore.text = mFloatLength( %this.totalScore, 0 ) @ "\n";
   %strokeScore = mFloatLength( %this.strokeScore, 0 );
   if( %strokeScore > 0 ) {
      StrokeScore.text =  "+" @ %strokeScore @ "\n";
   } else {
      StrokeScore.text = "\n";
   }
   
   %timeMultiplier = %this.strokeTimeMultiplier;
   if( %timeMultiplier > 1 ) {
      %multipliersText = "+" @ %timeMultiplier @ "\n";
   }
   %powerMultiplier = %this.strokePowerMultiplier;
   if( %powerMultiplier > 1 ) {
      %multipliersText = %multipliersText @ "+" @ %powerMultiplier @ "\n";
   }
   %comboMultiplier = %this.strokeComboMultiplier;
   if( %comboMultiplier > 1 ) {
      %multipliersText = %multipliersText @ "+" @ %comboMultiplier @ "\n";
   }
   
   if( %multipliersText !$= "" ) {
      %multipliersText = "x" SPC %multipliersText;
   }
   %multipliersText = %multipliersText @ "\n";
   Multipliers.text = %multipliersText;
}

function Score::startFirework( %this ) {
   %contours = %this.sceneGraph.contours;
   %count = %contours.getCount();
   for( %i = 0 ; %i < %count ; %i++ ) {
      %contour = %contours.getObject( %i );

      %contour.createFirework();
      %contour.postEvent( delete );
      //%contour.schedule( 0, delete );
   }
}