// Andreas Kirsch 2007

$Stroke::Layer = 10;

function t2dSceneGraph::createStroke( %this, %startPosition ) {
   if( isObject( %this.currentStroke ) ) {
      %this.currentStroke.finish();
   }
   
   Score.startStroke();
   
   %stroke = %this.currentStroke = new t2dParticleEffect() {
      class = Stroke;
      sceneGraph = %this;
      effectFile = "~/data/particles/magic_trail.eff";
      
      position = %startPosition;
      
      lastPosition = %startPosition;
      lastTime = %this.getSceneTime();
      
      layer = $Stroke::Layer;
      
      previousContourPoints = "";
   };

   %stroke.playEffect( true );
   %stroke.setTimerOn( 1/30 * 1000.0 );
}

function Stroke::updatePosition( %this, %position ) {   
   %sceneGraph = %this.sceneGraph;
   
   %contourPoints = %sceneGraph.pickLine( %this.lastPosition, %position, bit( $Contour::CollisionGroup ) );
   
   // TODO: use object mouse events instead
   %strokeValid = Score.processStrokeUpdate( %contourPoints );
   
   // gfx part
   if( %strokeValid ) {
      // valid stroke
      %this.setColor( 0.0, 1.0, 1.0, 1.0 );
   } else {
      // bad stroke
      %this.setColor( 1.0, 0.0, 0.0, 1.0 );
   }   

   %time = %this.getSceneTime();
   %deltaTime = %time - %this.lastTime;
   %delta = mAbs( t2dVectorDistance( %this.lastPosition, %position ) );
   
   %speed = %delta / %deltaTime;
   
   %quantityScale = mClamp( %speed / 25.0, 0.1, 4 );
   %this.setQuantityScale( %quantityScale );
   
   %this.lastPosition = %position;
   %this.lastTime = %time;
   
   //%this.moveTo( %position, %speed * 5, true, false, true, 0.02 );   
   %this.setPosition( %position );
}

function Stroke::finish( %this ) {
   Score.finishStroke();
   
   %this.setTimerOff();
   %this.safeDelete();
}

function Stroke::setColor( %this, %red, %green, %blue, %alpha ) {
   %emitter = %this.getEmitterObject( 0 );
   %emitter.selectGraph( "red_life" );
   %emitter.setDataKeyValue( 0, %red );
   %emitter.selectGraph( "green_life" );
   %emitter.setDataKeyValue( 0, %green );
   %emitter.selectGraph( "blue_life" );
   %emitter.setDataKeyValue( 0, %blue );
   %emitter.selectGraph( "visibility_life" );
   %emitter.setDataKeyValue( 0, %alpha );
}

// TODO: remove setColor and setQuantityScale from Stroke
//function Stroke::setQuantityScale( %this, %quantityScale ) {
   //%this.selectGraph( "quantity_scale" );
   //%this.setDataKeyValue( 0, %quantityScale );   
//}
