// Andreas Kirsch 2007

// uiButton extends t2dCustomButton

// fields
//    text

$uiButton::positionNudge = "5 0";

function uiButton::onLevelLoaded( %this, %sceneGraph ) {
   // create the particle effect
   %this.leftEffect = new t2dParticleEffect() {
      sceneGraph = %sceneGraph;
      
      effectFile = "~/data/particles/magic_trail.eff";
      
      position = t2dVectorSub( t2dVectorAdd( %this.position, t2dVectorMult( %this.size, "-0.5 0" ) ), $uiButton::positionNudge);
   };
   %this.rightEffect = new t2dParticleEffect() {
      sceneGraph = %sceneGraph;
      
      effectFile = "~/data/particles/magic_trail.eff";
      
      position = t2dVectorAdd( t2dVectorAdd( %this.position, t2dVectorMult( %this.size, "0.5 0" ) ), $uiButton::positionNudge);
   };
   
   Parent::onLevelLoaded( %this, %sceneGraph );
}

function uiButton::updateAppearance( %this, %type ) {
   switch( %type ) {
      case $t2dCustomButton::renderNormally:
         %this.leftEffect.stopEffect( true, false );
         %this.rightEffect.stopEffect( true, false );
      case $t2dCustomButton::renderHighlit:
         %this.leftEffect.playEffect( false );
         %this.rightEffect.playEffect( false );
         
         %this.leftEffect.setColor( 0.0, 1.0, 0.0, 0.5 );
         %this.rightEffect.setColor( 0.0, 1.0, 0.0, 0.5 );
      case $t2dCustomButton::renderActivated:
         %this.leftEffect.playEffect( false );
         %this.rightEffect.playEffect( false );
         
         %this.leftEffect.setColor( 1.0, 0.0, 1.0, 1.0 );
         %this.rightEffect.setColor( 1.0, 0.0, 1.0, 1.0 );
   }
}